package org.implab.gradle.containers.tasks;

import java.util.List;
import java.util.concurrent.Callable;

import org.gradle.api.provider.ListProperty;
import org.gradle.api.provider.Property;
import org.gradle.api.tasks.Input;
import org.gradle.api.tasks.Optional;
import org.implab.gradle.containers.ImageName;

public abstract class TagImage extends CliTask {

    @Input
    public abstract Property<ImageName> getSrcImage();

    @Input
    public abstract Property<ImageName> getDestImage();

    @Input
    @Optional
    public abstract Property<String> getTransport();

    @Input
    @Optional
    public abstract ListProperty<String> getOptions();

    public TagImage option(Callable<String> provider) {
        getOptions().add(getProject().provider(provider));
        return this;
    }

    @Override
    protected void preparingCommand(List<String> commandLine) {
        super.preparingCommand(commandLine);

        commandLine.add("tag");
        commandLine.addAll(getOptions().get());
        commandLine.add(getSrcImage().get().toString());
        commandLine.add(getDestImage().get().toString());
    }
}
